<template>
	<el-dialog :title="titleMap[mode]" v-model="visible" :width="500" destroy-on-close @closed="$emit('closed')">
		<el-form :model="form" :rules="rules" :disabled="mode=='show'" ref="dialogForm" label-width="100px">
			<el-form-item label="上级分组" prop="parent_id">
				<el-cascader v-model="form.parent_id" :options="depts" :props="deptsProps" :show-all-levels="false" clearable style="width: 100%;"></el-cascader>
			</el-form-item>
			<el-form-item label="分组名称" prop="name">
				<el-input v-model="form.name" placeholder="请输入分组名称" clearable></el-input>
			</el-form-item>
			<el-form-item label="状态" prop="active_status">
				<el-switch v-model="form.active_status" :active-value="true" :inactive-value="false"></el-switch>
			</el-form-item>
			<el-form-item label="备注" prop="remark">
				<el-input v-model="form.remark" clearable type="textarea"></el-input>
			</el-form-item>
		</el-form>
		<template #footer>
			<el-button @click="visible=false" >取 消</el-button>
			<el-button v-if="mode!='show'" type="primary" :loading="isSave" @click="submit()">保 存</el-button>
		</template>
	</el-dialog>
</template>

<script>
	export default {
		emits: ['success', 'closed'],
		data() {
			return {
				mode: "add",
				titleMap: {
					add: '新增',
					edit: '编辑',
					show: '查看'
				},
				visible: false,
				isSave: false,
				//表单数据
				form: {
					parent_id: "",
					id:"",
					name: "",
					active_status: true,
					remark: ""
				},
				//验证规则
				rules: {
					name: [
						{required: true, message: '请输入部门名称'}
					],
					active_status: [
						{required: true,}
					],
				},
				//所需数据选项
				depts: [],
				deptsProps: {
					value: "id",
					emitPath: false,
					checkStrictly: true
				}
			}
		},
		mounted() {
			this.getGroup()
		},
		methods: {
			//显示
			open(mode='add'){
				this.mode = mode;
				this.visible = true;
				return this
			},
			//加载树数据
			async getGroup(){
				const res = await this.$API.system.dept.active.post();
				if(res.code == 200){
					this.depts = res.data;
				}
			},
			//表单提交方法
			submit(){
				this.$refs.dialogForm.validate(async (valid) => {
					if (valid) {
						this.isSave = true;
						const res = await this.$API.system.dept.add.post(this.form);
						this.isSave = false;
						if(res.code == 200){
							this.$emit('success', this.form, this.mode)
							this.visible = false;
							this.$message.success("操作成功")
						}
					}
				})
			},
			//表单注入数据
			async setData(data) {
				let params = {
					id: data.id
				}
				const res = await this.$API.system.dept.info.post(params);
				if (res.code == 200) {
					this.form = res.data;
				}
			}
		}
	}
</script>

<style>
</style>
